#define MEMSIZE 4096*100

#include "../lib/io.h"
#include "../lib/math.h"
#include "../lib/random.h"
#include "../lib/draw_buf.h"

proc_info Form;

DrawBufer canvas;

#define WINDOW_MODE_NORMAL 0x73
#define WINDOW_MODE_FULLSCREEN 0x01
int window_mode = WINDOW_MODE_NORMAL;
int window_normal_mode_x;
int window_normal_mode_y;
int window_normal_mode_w;
int window_normal_mode_h;

void EventChangeWindowMode() 
{
	debugi(11);
	if (window_mode == WINDOW_MODE_NORMAL) 
	{
		window_mode = WINDOW_MODE_FULLSCREEN;
		window_normal_mode_x = Form.left;
		window_normal_mode_y = Form.top;
		window_normal_mode_w = Form.width;
		window_normal_mode_h = Form.height;
		MoveSize(0, 0, screen.width, screen.height);
	}
	else {
		window_mode = WINDOW_MODE_NORMAL;
		MoveSize(window_normal_mode_x, window_normal_mode_y, window_normal_mode_w, window_normal_mode_h);
	}
	EventDrawWindow();
}

void EventDrawWindow()
{
	DefineAndDrawWindow(215,100,500+9,400+skin_height+4,window_mode,0xFFFFFF,"Starfield (F - fullscreen)");
	GetProcessInfo(#Form, SelfInfo);
	if (window_mode == WINDOW_MODE_NORMAL) canvas.Init(0, 0, Form.cwidth, Form.cheight);
	else canvas.Init(0, 0, Form.width, Form.height);
}

void main()
{
	initStars();
	loop() {
		WaitEventTimeout(1);
		switch(EAX & 0xFF)
		{
			case evButton:
				ExitProcess();
				break;
			case evKey:
				GetKeys();
				if (key_scancode == 33) EventChangeWindowMode();
				if (key_scancode == SCAN_CODE_ESC) ExitProcess();
				break;
			case evReDraw:
				EventDrawWindow();
			default:
				if (buf_data) drawStars();
		}
	}
}

#define MAX_DEPTH 32;
#define STARS_COUNT 512

struct star
{
	int x;
	int y;
	float z;
} stars[STARS_COUNT];

int randomRange(int minVal,maxVal) {
	float rand;
	randomize();
	rand = random(100)/100;
	return math.floor( maxVal - minVal - 1 * rand ) + minVal;
}

void initStars() {
	int i, temp;
	char m[256];
	for( i = 0; i < STARS_COUNT; i++ ) {
		stars[i].x = randomRange(-canvas.bufw,canvas.bufw);
		stars[i].y = randomRange(-canvas.bufh,canvas.bufh);
		stars[i].z = randomRange(1,MAX_DEPTH);
	}
}

void drawStars() {
	float k;
	float temp;
	int i, shade, px, py, size;
	int halfWidth  = canvas.bufw / 2;
	int halfHeight = canvas.bufh / 2;
	dword color;

	canvas.Fill(0);

	for( i = 0; i < STARS_COUNT; i++ ) 
	{
		stars[i].z -= 0.2;

		k  = 128.0 / stars[i].z;
		px = math.ceil(stars[i].x * k + halfWidth);
		py = math.ceil(stars[i].y * k + halfHeight);

		if( (px >= 0) && (px + 5 <= canvas.bufw) && (py >= 0) && (py + 5 <= canvas.bufh) && (stars[i].z > 0) ) {
			temp = stars[i].z / 32.0;
			size = math.ceil(1 - temp * 5);
			if (size>5) debugi(math.ceil(stars[i].z));
			shade = math.ceil(1 - stars[i].z * 255 / 32.0);
			color = (unsigned) calc(shade << 16) + calc(shade << 8) + shade;
			canvas.DrawBar(px, py, size, size, color);
		}
		else {
			stars[i].x = randomRange(-25,25);
			stars[i].y = randomRange(-25,25);
			stars[i].z = MAX_DEPTH;
		}
	}
	canvas.Show();
}

/*

// ORIGINAL DEMO CAN BE FOUND AT
// http://codentronix.com/projects/html5/3d/canvas-3d-starfield.html


MAX_DEPTH = 32;

var canvas, ctx;
var stars = new Array(512);

window.onload = function() {
  canvas = document.getElementById("tutorial");
  if( canvas && canvas.getContext ) {
    ctx = canvas.getContext("2d");
    initStars();
    setInterval(loop,33);
   }
}

// Returns a random number in the range [minVal,maxVal] 
function randomRange(minVal,maxVal) {
  return Math.floor(Math.random() * (maxVal - minVal - 1)) + minVal;
}

function initStars() {
  for( var i = 0; i < stars.length; i++ ) {
    stars[i] = {
      x: randomRange(-25,25),
      y: randomRange(-25,25),
      z: randomRange(1,MAX_DEPTH)
     }
  }
}

function loop() {
  var halfWidth  = canvas.width / 2;
  var halfHeight = canvas.height / 2;
  
  ctx.fillStyle = "rgb(0,0,0)";
  ctx.fillRect(0,0,canvas.width,canvas.height);

  for( var i = 0; i < stars.length; i++ ) {
    stars[i].z -= 0.2;

    if( stars[i].z <= 0 ) {
      stars[i].x = randomRange(-25,25);
      stars[i].y = randomRange(-25,25);
      stars[i].z = MAX_DEPTH;
    }

    var k  = 128.0 / stars[i].z;
    var px = stars[i].x * k + halfWidth;
    var py = stars[i].y * k + halfHeight;

    if( px >= 0 && px <= 500 && py >= 0 && py <= 400 ) {
      var size = (1 - stars[i].z / 32.0) * 5;
      var shade = parseInt((1 - stars[i].z / 32.0) * 255);
      ctx.fillStyle = "rgb(" + shade + "," + shade + "," + shade + ")";
      ctx.fillRect(px,py,size,size);
    }
  }
}
  
*/
